###############################################################################
# (c) 2007 Rico Schulte
# This Software is Free, use it where you want, when you want for whatever you want and modify it if you want but don't remove my copyright!
###############################################################################
from twisted.internet import reactor
from twisted.web2 import server, http, resource, channel,static

import os,time

import config
import buildPackage

__author__ = "Rico Schulte, 3c5x9 at gmx net"
__version__ = "1.0"


    

class PackageList(resource.Resource):

    def render(self, ctx):
        html = getHeader("List avaible Packages")
        html += "<table border=\"1\" width=\"100%\">"
        html += "<tr>"
        html += "<th>Details</th>" 
        html += "<th>Download</th>" 
        html += "<th>Name</th>"
        html += "<th>Size</th>"
        html += "</tr>"
        for ipkgfile in buildPackage.getIPKGs(config.PATH_TO_OE_IPK_DIR):
            html += "<tr>"
            html += "<td><a href=\"/details?file=%s\">details</a></td>" % ipkgfile
            html += "<td><a href=\"/feed/%s\">download</a></td>" % ipkgfile
            html += "<td>%s</td>" % ipkgfile
            html += "<td>%i</td>" % os.path.getsize(config.PATH_TO_OE_IPK_DIR+ipkgfile)
            html += "</tr>"
        html += "</table>"
        html += getFooter()
        return http.Response(stream=html)
#########################
class PackageDetails(resource.Resource):

    def render(self, ctx):
        if ctx.args.has_key('file') is not True:
            return http.Response(stream="no file givven")
        else:
            ipkgfile = ctx.uri.split("=")[-1]
            if os.path.isfile(config.PATH_TO_OE_IPK_DIR+ipkgfile) is not True:
                return http.Response(stream="givven file not found "+config.PATH_TO_OE_IPK_DIR+ipkgfile)
            else:
                metadata = buildPackage.getPackageMetadata(config.PATH_TO_OE_IPK_DIR, ipkgfile)
                
                html = getHeader("Details of Package "+ipkgfile)
                html += metadata.replace("\n","<br>")
                html += getFooter()
                return http.Response(stream=html)

#########################
class Toplevel(resource.Resource):
    addSlash = True
    child_feed = static.File(config.PATH_TO_OE_IPK_DIR)
    child_list = PackageList()
    child_details = PackageDetails()
    
    def render(self, ctx):
        html = getHeader("Openembedded Feedserver")
        html += "The entry in /etc/ipkg/official-feed.conf should be:<br>"
        html += "<b>src/gz official http://<i>&lt;ipofthisserver&gt;</i>:%i/feed</b><br>"%config.WEBSERVERPORT
        html += "<br>Server is managing %i IPKG Files" %len(buildPackage.getIPKGs(config.PATH_TO_OE_IPK_DIR))
        html += "<br>Current <a href=\"/feed/Packages.gz\">Packages.gz</a> was build on "+time.strftime("%d.%m.%Y %H:%M:%S",time.localtime(os.path.getctime(config.PATH_TO_OE_IPK_DIR+"Packages.gz")))
        html += getFooter()
        return http.Response(stream=html)

    def locateChild(self, request, segments):
        print "REQUEST:",request.remoteAddr.host, request.method,request.uri
        return resource.Resource.locateChild(self, request, segments)
    
#######################
def getHeader(title):
    html  = "<html>"
    html += "<head><title>%s</title></head>"%title
    html += "<body>"
    html +=  """<table><tr>
            <td>[<a href=\"/\">top</a>]</td>
            <td>[<a href=\"/feed\">show Files</a>]</td>
            <td>[<a href=\"/list\">Package List</a>]</td>
            </tr></table><br>"""
    return html
#######################
def getFooter():
    html = "<hr>Openembedded Feedserver, V"+str(__version__)+", written by "+__author__
    html += "</body>"
    html +="</html>"
    return html

if config.CONFIGURED is not True:
    print "configure config.py first!!!"
else:
    site = server.Site(Toplevel())
    reactor.listenTCP(config.WEBSERVERPORT, channel.HTTPFactory(site))
    
    print " Server started on Port "+ str(config.WEBSERVERPORT)+""
    print " Point your Browser to http://localhost:"+str(config.WEBSERVERPORT)
    print " to stop the server, press CTRL+C"
    
    reactor.run()




